<?php if (!defined('ABSPATH')) exit; ?>

<style>
    .input-month {
        width: 35% !important;
        margin-right: 5%;
    }
    
    .input-year {
        width: 42% !important;
    }
    
    .input-cvv {
        width: 50% !important;
    }
    
    @media (max-width: 767px) {
        .fix-width-input {
            width: 100% !important;
        }
    }
</style>

<fieldset class="galax-pay-fieldset">
    <div class='galax-pay-new-cc-data'>

        <p class="form-row form-row-wide">
            <label for="cardNumber">
                <?php _e("Número do cartão", GALAX_IDENTIFIER); ?>
                <span class="required">*</span>
            </label>
            <input type="text" class="input-text wc-credit-card-form-card-number" maxlength="20" name="cardNumber" autocomplete="off" placeholder="" style="padding-right:55px" />
        </p>

        <p class="form-row form-row-wide">
            <label for="cardHolder">
                <?php _e("Nome impresso no cartão", GALAX_IDENTIFIER); ?>
                <span class="required">*</span>
            </label>
            <input type="text" class="input-text" name="cardHolder" />
        </p>
        <div class="clear"></div>
        <p class="form-row form-row-first fix-width-input">
            <label for="cardMonthExpiry"><?php _e("Data de validade", GALAX_IDENTIFIER) ?>
                <span class="required">*</span>
            </label>

            <input type="text" class="input-text input-month fix-width-input" name="cardMonthExpiry" placeholder="MM"/>
            <input type="text" class="input-text input-year fix-width-input" name="cardYearExpiry" placeholder="AAAA"/>
        </p>
        <p class="form-row form-row-last fix-width-input">
            <label for="cardCvv">
                <?php _e("Código de segurança", GALAX_IDENTIFIER); ?>
                <span class="required">*</span>
            </label>
            <input type="text" class="input-text input-cvv fix-width-input" name="cardCvv" placeholder="CVV" autocomplete="off" minlength="3" maxlength="4"/>
        </p>
    </div>
    <?php if ($installments > 1) { ?>
        <p class="form-row form-row-wide">
            <label for="installmentsNumber"><?php _e("Número de Parcelas", GALAX_IDENTIFIER); ?>
                <span class="required">*</span>
            </label>
            <select name="installmentsNumber" class="input-text" style="width: 100%">
                <?php /* foreach ($installments as $installment => $price) { ?>
                    <option value="<?php echo $installment; ?>"><?php echo sprintf(__('%dx de %s', GALAX_IDENTIFIER), $installment, wc_price($price)); ?></option>
                <?php } */ ?>
                <?php foreach ( $installments as $value => $label ) : ?>
						<option value="<?= esc_attr( $value ); ?>">
							<?= $label; ?>
						</option>
					<?php endforeach; ?>
            </select>
        </p>
    <?php } ?>
    <div class="clear"></div>
</fieldset>